/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.statistik.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.statistik.entity.StatistikLauf;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractStatistikLaufSearch {

  @Inject
  protected transient StatistikLaufExtendedDAO dao;

  public AbstractStatistikLaufSearch() {
    super();
  }

  public List<StatistikLauf> getSearchResult(StatistikLaufSearchParameters searchParameters, EagerLoadingCollector<StatistikLauf> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<StatistikLauf> querySearchResult(StatistikLaufSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
